// librairie pour SOMO14D
// C.Dupaty 06/2011

#include <delays.h>
#include "somo14d.h"

// tempo calculees pour FOSC=32MHz
// FCY=8MHz TCY=125nS
void tempo_rst(void) // 5ms
{
	Delay1KTCYx(40); 	// 40.000 cycles
}

void tempo_rst_start(void) // 300ms
{
	unsigned char c;
	for (c=0;c<10;c++) 
	Delay10KTCYx(240); 	// 2.400.000 cycles
}

void tempo_start(void) // 2ms 
{
	Delay1KTCYx(16);// 16.000 cycles
}

void tempo_stop(void)  // 2ms
{
	Delay1KTCYx(16);  // 16.000 cycles
}

void tempo_high(void) // 100us
{
	Delay100TCYx(8);  // 800 cycles
}

void tempo_low(void)  // 100us
{
	Delay100TCYx(8);  // 800 cycles
}

void tempo_busy(void)  // 30ms
{
	Delay10KTCYx (24);  // 300.000 cycles
}

void init_SOMO14D(void)
{
	tris_busy=1;
	trid_data=0;
	tris_clk=0;
	tris_rst=0;
	rst=1;
	clk=1;
	data=0;
// RESET du module SOMO14D
	rst=0;
	tempo_rst();
	rst=1;
	tempo_rst_start();
}


// emet commande vers SOMO14D
// attend fin occupation
// tempo start
// emet les 16bits de la commande PF_Pf enregistrement sur front montant
// attend positionnement ligne busy
void emet_cmd(unsigned int cmd)
{
	unsigned int i;

	while(busy);
	tempo_busy();
	clk=0;
	tempo_start();
	for (i=0x8000;i>0;i>>=1)
		{
			if (i&cmd) data=1;
			else data=0;
			clk=0;
			tempo_low();
			clk=1;
			tempo_high();
		}
	tempo_busy();
	while(busy);
}