// demo pour SOMO14D
// C.Dupaty 06/2011
// Le programme "dit" le nombre rsultat de la conversion analogique numrique
// sur AN0 (Sur PICDEM2+ le potentiomtre est sur AN0)

#include <p18f2620.h>
#include "init_horloge_interne.h"
#include "somo14d.h"
#include "sons.h"

// bouton S2 sur carte PICDEM2+
#define S2 PORTAbits.RA4
#define trisS2 TRISAbits.TRISA4

// cent, dix et un representent le chiffre centaines dizaines unites de nombre
typedef struct {
				unsigned char cent;
				unsigned char dix;
				unsigned char un;
			   } nombre;

//----------------------------------------------------------------------------
// ADC 8bits
//----------------------------------------------------------------------------
unsigned char adc(void)
{		
		ADCON0bits.GO_DONE=1;		// SOC
		while(ADCON0bits.GO_DONE);	// attend EOC
		return (ADRESH);				// calcule la tension
}

//----------------------------------------------------------------------------
// isole centaines dizaines et unite
//----------------------------------------------------------------------------
void cdu(unsigned char x, nombre *nb)
{
unsigned char c,d,u;
	c=x/100;			// calcul chiffre centaines
	d=(x-c*100)/10;		// calcul chiffre dizaine
	u=x-c*100-d*10;		// calcul chiffre unite
	nb->cent=c;			// range c dans structure
	nb->dix=d;			// range d dans structure
	nb->un=u;			// range u dans structure
}

//----------------------------------------------------------------------------
// Programme principal
//----------------------------------------------------------------------------
void main (void)
{
unsigned char n; 	// nombre  dire
nombre nbadire;		// structure pour le nombre a dire 

	init_horloge_interne(); // le PIC est sur horloge interne FOSC32MHz
	init_SOMO14D();			// initialise les PORTS connects au module SOMO14D
							// le fichier SOMO14D.h DOIT ETRE CONFIGURE EN FONCTION DU CABLAGE

	// init CAN 
	ADCON0=1;				// CAN on. CLOCK=FOSC/2. CANAL0 (RA)
	ADCON1=0b00001110;	// justification  gauche (resultat 8bits ADRESH)
						// , seul AN0 est activ, VREF+=VDD VREF-=VSS
	ADCON2=0b00100001;	// clk  = 1Mhz (fosc /8), acq Time = 8Tad
	// port sur S2 en entree
	trisS2=1;

	// dit message d'introduction
	emet_cmd(intro);
	
	while(1)
		{
			while (S2);	// attend appui et relachement de S2
			while(!S2);
			n=adc();	 // mesure de AN0 dans n
			cdu(n,&nbadire); 	// isole cent dix et un de n et range dans structure nbadire
			if (nbadire.cent) {
									if (nbadire.cent>1)emet_cmd(nbadire.cent);
									emet_cmd(100);											// dit les centaines
							  }					
			if ((nbadire.dix>1 && nbadire.dix<7) || (nbadire.dix==8) ) emet_cmd(nbadire.dix*10);	//20 30 40 50 60 80
			else if ((nbadire.dix==7) || (nbadire.dix==9) )emet_cmd((nbadire.dix-1)*10);			// dire 60 pour 70 et 90
			if ((nbadire.dix>1 && nbadire.dix<8 && nbadire.un==1)  ) emet_cmd(et);			// -et- pour 21 31 41 51 61 71
			if (nbadire.dix==1 || nbadire.dix==7 || nbadire.dix==9)emet_cmd(10+nbadire.un); 		// 10 11 12 13 14 15 16 17 18 19
			else if (nbadire.un)emet_cmd(nbadire.un);											// 1 2 3 4 5 6 7 8 9
			if (!nbadire.cent && !nbadire.dix && !nbadire.un )emet_cmd(0);					// 0

			emet_cmd(unites);		// dit simplement -unites-
		}
}
